package com.sf.web.dms.statistics.control;

package ..deTemp.1731161516156;

import com.sf.web.dms.common.service.ModelService;
import com.sf.web.dms.statistics.bean.RtuOnlineParaVO;
import com.sf.web.dms.statistics.bean.ScadaEventBean;
import com.sf.web.dms.statistics.bean.StatisticsParaVO;
import com.sf.web.dms.statistics.proxy.Zone1QueryHandler;
import com.sf.web.dms.statistics.service.StatisIndexService;
import com.sf.web.dms.util.SysCommUtil;
import com.smartframework.core.annotation.SmartComment;
import com.smartframework.core.dao.page.PagingBean;
import com.smartframework.core.i18n.I18n;
import com.smartframework.core.smart.SmartView;
import com.smartframework.web.core.control.BasicControl;
import com.smartframework.web.core.queryfilter.QueryFilter;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@SmartComment("StatisHost实例增删改查接口层")
public class StatisIndexControl extends BasicControl {
  private StatisIndexService statisIndexService;
  
  private ModelService modelService;
  
  public StatisIndexService getStatisIndexService() {
    return this.statisIndexService;
  }
  
  public void setStatisIndexService(StatisIndexService statisIndexService) {
    this.statisIndexService = statisIndexService;
  }
  
  public ModelService getModelService() {
    return this.modelService;
  }
  
  public void setModelService(ModelService modelService) {
    this.modelService = modelService;
  }
  
  @SmartComment("发送指标消息")
  public SmartView sendToZone1(Integer requestId, Map<String, Object> jsonMap) {
    this.logger.info("+++++ sendToZone1 +++++");
    (new Zone1QueryHandler(requestId, jsonMap)).start();
    return SmartView.SUCCESS("启动线程查询并发送指标信息");
  }
  
  @SmartComment("获取遥控成功率查询结果")
  public SmartView queryRemoteControl(ScadaEventBean queryPara) {
    QueryFilter queryFilter = null;
    try {
      queryFilter = queryPara.getQueryFilter(null, null);
    } catch (Exception e) {
      return SmartView.ERROR(e.getMessage());
    } 
    Map<String, Object> records = this.statisIndexService.queryRemoteControl(queryFilter, queryPara.getLevel(), queryPara.getOrgId(), null);
    return SmartView.SUCCESS(records);
  }
  
  @SmartComment("获取遥控使用率查询结果")
  public SmartView queryYkUseRate(ScadaEventBean queryPara) {
    QueryFilter queryFilter = null;
    try {
      queryFilter = queryPara.getQueryFilter(null, null);
    } catch (Exception e) {
      return SmartView.ERROR(e.getMessage());
    } 
    Map<String, Object> records = this.statisIndexService.queryYkUseRate(queryFilter, queryPara.getLevel(), queryPara.getOrgId(), null);
    return SmartView.SUCCESS(records);
  }
  
  @SmartComment("获取遥信正确率查询结果")
  public SmartView querySignalAccuracy(ScadaEventBean queryPara) {
    QueryFilter queryFilter = null;
    try {
      queryFilter = queryPara.getQueryFilter(null, null);
    } catch (Exception e) {
      return SmartView.ERROR(e.getMessage());
    } 
    Map<String, Object> records = this.statisIndexService.querySignalAccuracy(queryFilter, queryPara.getLevel(), queryPara.getOrgId(), null);
    return SmartView.SUCCESS(records);
  }
  
  @SmartComment("获取终端覆盖率查询结果")
  public SmartView queryRtuCover(Long stationId, Long feederId, Integer level, Integer orgId) {
    Map<String, Object> records = this.statisIndexService.queryRtuCover(stationId, feederId, level, orgId, null);
    return SmartView.SUCCESS(records);
  }
  
  @SmartComment("根据馈线类型获取终端覆盖率查询结果")
  public SmartView queryRtuCoverByType(Long stationId, Long feederId, Integer objType, Integer level, Integer orgId) {
    Map<String, Object> records = this.statisIndexService.queryRtuCoverByType(stationId, feederId, objType, level, orgId, null);
    return SmartView.SUCCESS(records);
  }
  
  @SmartComment("获取历史终端在线率查询结果")
  public SmartView queryRtuOnline(RtuOnlineParaVO queryPara) {
    QueryFilter queryFilter0 = null;
    QueryFilter queryFilter1 = null;
    QueryFilter queryFilter2 = null;
    try {
      queryFilter0 = queryPara.getQueryFilter0(null, null);
      queryFilter1 = queryPara.getQueryFilter1(null, null);
      queryFilter2 = queryPara.getQueryFilter2(null, null);
    } catch (Exception e) {
      return SmartView.ERROR(e.getMessage());
    } 
    Date endTime = new Date();
    if (queryPara.getTimeRange() != null && (queryPara.getTimeRange()).length == 2 && queryPara.getTimeRange()[1] != null)
      endTime = queryPara.getTimeRange()[1]; 
    Map<String, Object> records = this.statisIndexService.queryRtuOnline(queryFilter0, queryFilter1, queryFilter2, endTime, queryPara.getLevel(), queryPara.getOrgId(), null, queryPara.getForceThreeDays());
    return SmartView.SUCCESS(records);
  }
  
  @SmartComment("在线终端率查询结果")
  public SmartView queryRtu3DaysOff(RtuOnlineParaVO queryPara) {
    QueryFilter queryFilter0 = null;
    QueryFilter queryFilter1 = null;
    try {
      queryFilter0 = queryPara.getQueryFilter0(null, null);
      queryFilter1 = queryPara.getQueryFilter1(null, null);
    } catch (Exception e) {
      return SmartView.ERROR(e.getMessage());
    } 
    Map<String, Object> records = this.statisIndexService.queryRtu3DaysOff(queryFilter0, queryFilter1, queryPara.getLevel(), queryPara.getOrgId(), null);
    return SmartView.SUCCESS(records);
  }
  
  @SmartComment("获取实时终端在线率查询结果")
  public SmartView queryRealtimeRtuOnline(StatisticsParaVO queryPara) {
    QueryFilter queryFilter = null;
    try {
      queryFilter = queryPara.getQueryFilter(null, null);
    } catch (Exception e) {
      return SmartView.ERROR(e.getMessage());
    } 
    Map<String, Object> records = this.statisIndexService.queryRealtimeRtuOnline(queryFilter, queryPara.getLevel(), queryPara.getOrgId(), null);
    return SmartView.SUCCESS(records);
  }
  
  @SmartComment("根据点id批量获取极值统计结果")
  public SmartView queryExtremeStatistics(Long devId, Date startTime, Date endTime, Integer pageSize, Integer pageIndex, String columns, String method) {
    if (devId == null)
      return SmartView.ERROR(I18n.message("parameter.not.valid", "设备id不能为空")); 
    List<Long> devList = this.modelService.loadSubsetDeviceList(devId);
    List<Map<String, Object>> pointsMap = this.modelService.loadMeasurementPoints(devList, null);
    List<Long> points = new ArrayList<>();
    for (Map<String, Object> item : pointsMap)
      points.add(Long.valueOf(Long.parseLong((String)item.get("id")))); 
    QueryFilter filter = new QueryFilter();
    filter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.statisIndexService.queryExtremeStatistics(points, startTime, endTime, filter);
    if ("export".equals(method))
      return SysCommUtil.exportExcel(columns, page, "极值统计.xls"); 
    return SmartView.PAGEDATA(page);
  }
  
  @SmartComment("获取终端覆盖率查询结果")
  public SmartView queryRtuCoverByFesType(Long stationId, Long feederId, List<Integer> fesTypeList, Integer level, Integer orgId) {
    Map<String, Object> records = this.statisIndexService.queryRtuCoverByFesType(stationId, feederId, fesTypeList, level, orgId);
    return SmartView.SUCCESS(records);
  }
}
